package List::KvStr;
# ABSTRACT: ログ出力用に度々使っている関数です。
$List::KvStr::VERSION = '0.01';
@EXPORT = ('kv_str');

use strict;
use Carp;
use Exporter 'import';

sub kv_str {
    unless (@_%2==0) {
        carp "The number of arguments is odd.";
    }

    my $str = '';
    while (@_) {
        my $k = shift;
        my $v = shift;

        if ( length $k ) {
            if ($k =~ /\s|"/) {
                $k = '"' . $k =~ s/"/\\"/gr . '"';
            }
        }
        else {
            $k = '""';
        }

        if ( length $v ) {
            if ($v =~ /\s|"/) {
                $v = '"' . $v =~ s/"/\\"/gr . '"';
            }
        }
        else {
            $v = '';
        }

        if ( length $str ) {
            $str .= " $k:$v";
        }
        else {
            $str  = "$k:$v";
        }
    }

    $str;
}

1;

__END__

=pod

=encoding UTF-8

=head1 NAME

List::KvStr - ログ出力用に度々使っている関数です。

=cut
