use Test::More;

use List::KvStr;
my $str;

$str = kv_str one => 'twe';
is $str, q|one:twe|;

$str = kv_str;
is $str, q||;

$str = kv_str one => 'twe', 'three';
is $str, q|one:twe three:|;

$str = kv_str one => 'twe', three => undef;
is $str, q|one:twe three:|;

$str = kv_str one => 'twe', three => '';
is $str, q|one:twe three:|;

$str = kv_str one => 'twe', three => 0;
is $str, q|one:twe three:0|;

$str = kv_str array => [];
like $str, qr/^array:ARRAY\(0x\S+\)$/;

$str = kv_str hash => {};
like $str, qr/^hash:HASH\(0x\S+\)$/;


$str = kv_str undef, 'v';
is $str, q|"":v|;

$str = kv_str "" => 'v';
is $str, q|"":v|;

$str = kv_str k => "";
is $str, q|k:|;

$str = kv_str "this is" => "a pen.";
is $str, q|"this is":"a pen."|;

$str = kv_str 'k"k' => 'v"v';
is $str, q|"k\"k":"v\"v"|;

done_testing;
